<template>
  <div class="page">
    <LayoutTable
      ref="layouttable"
      :data="tableData"
      :config="tableConfig"
      notDel
    >
      <!-- 热门0为非热门1为热门 -->
      <div slot="table-search-left" class="onlyhot">
        <el-checkbox
          :key="0"
          v-model="ishot"
          :checked="ishot"
          @change="changeIshot"
        >
        </el-checkbox>
        只看热门
      </div>
    </LayoutTable>

    <drawer-show ref="drawerform" @ok="getData" />
  </div>
</template>

<script>
/** 表单弹出框模式需引入 */
import drawerShow from "./drawershow";
import table from "@/assets/mixins/table";
export default {
  name: "ProductList",
  components: {
    drawerShow,
  },
  mixins: [table],
  mounted() {
    // 重写查询
    this.$refs.layouttable.$refs.searchform.onSubmit = this.onSearch;
    // 重写搜索清除
    this.$refs.layouttable.$refs.searchform.cleanForm = this.cleanForm;
  },
  methods: {
    renderTable(tableData) {
      return (
        <el-table stripe data={tableData} class="total-table">
          {this.columnSet.map((item) => this.renderTableColumn(item))}
        </el-table>
      );
    },
    renderTableColumn(options) {
      return (
        <el-table-column
          prop={options.prop}
          label={options.label}
          width={options.width}
          formatter={options.formatter}
        ></el-table-column>
      );
    },
    /** 重写新增方法 */
    toAdd(row) {
      this.$refs.drawerform.add(row);
    },
    /** 重写编辑方法 */
    toEdit(row) {
      this.$refs.drawerform.edit(row);
    },
    /** 重写查看方法 */
    toView(row) {
      this.$refs.drawerform.view(row);
    },
    // 重写查询
    onSearch() {
      if (this.ishot) {
        this.$refs.layouttable.$refs.searchform.form = Object.assign(
          {},
          this.$refs.layouttable.$refs.searchform.form,
          { hot: 1 }
        );
      } else {
        this.$refs.layouttable.$refs.searchform.form = Object.assign(
          {},
          this.$refs.layouttable.$refs.searchform.form,
          { hot: "" }
        );
      }
      let { path, query } = this.$refs.layouttable.$refs.searchform.$route;
      let data = this.$refs.layouttable.$refs.searchform.decode(
        this.$refs.layouttable.$refs.searchform.form
      );
      this.$refs.layouttable.$refs.searchform.$router.push({
        path: path,
        query: Object.assign({}, query, data),
      });
    },
    // 重写搜索清除
    cleanForm() {
      this.ishot = false;
      this.$refs.layouttable.$refs.searchform.form.hot = undefined;
      this.$forceUpdate();
      this.$refs.layouttable.$refs.searchform.clean();
      this.$refs.layouttable.$refs.searchform.onSubmit();
    },
    changeIshot(val) {
      this.ishot = val;
      this.onSearch();
    },
  },
  data() {
    return {
      ishot: false,
      config: {
        search: [
          {
            name: "categoryId",
            type: "select",
            placeholder: "请选择产品分类",
            label: "产品分类",
          },
          {
            name: "companyId",
            type: "select",
            placeholder: "请选择所属企业",
            label: "所属企业",
          },
          {
            name: "productName",
            type: "text",
            label: "产品名称",
            fuzzy: true,
          },
        ],
        columns: [
          { type: "index", label: "序号", width: 50 },

          { label: "产品名称", prop: "productName" },

          {
            label: "产品分类",
            prop: "categoryId",
            formatter: this.formatters,
            width: 140,
          },

          {
            label: "所属企业",
            prop: "companyId",
            formatter: this.formatters,
            width: 300,
          },

          {
            label: "产品介绍",
            prop: "productIntroduction",
            width: 500,
            formatter: this.formatters,
          },

          {
            label: "发布时间",
            prop: "publishTime",
            formatter: this.formatterDate,
            width: 150,
          },

          {
            label: "热门",
            prop: "hot",
            formatter: this.formatterYES,
            width: 60,
          },

          {
            label: "最近更新时间",
            prop: "updateTime",
            formatter: this.formatterDate,
            width: 150,
          },

          {
            label: "操作",
            width: 140,
            formatter: (row) => {
              return (
                <table-buttons
                  noAdd
                  noView
                  row={row}
                  onEdit={this.toEdit}
                  onView={this.toView}
                  onDel={this.toDel}
                />
              );
            },
          },
        ],
      },
    };
  },
};
</script>
<style lang="less" >
.table-form {
  display: flex;
}
.onlyhot {
  margin-right: 20px;
  line-height: 30px;
  font-size: 14px;
  color: #333333;
}
</style>